{* This is a Microsoft Windows 3.1 interface to the Btrieve TSR.
*  Requires Turbo Pascal version 7.0
*
*  IT CANNOT BE USED FOR REAL MODE OR PROTECTED MODE!!!!!
*
*}

UNIT BtrvWin;


INTERFACE

{Standard Btrieve Operation Call}
Function BTRV(    Operation: integer;
              var posblk;
              var databuf;
              var datalen  : word;
              var keybuf;
                  keylen   : byte;
                  keynum   : byte): integer;

{Initializes the local DLL}
Function BtrvInit(Var InitializationString): Integer;

{Stops this instance of Btrieve}
Function BtrvStop: Integer;

{This function is currently not supported. You initialize brequest.exe
 when you load it before loading Windows. Therefore, there is no need
 to initialize the WBTRCALL.DLL requestor from your Windows application.
 Separate initialization for each task using the requestor may be supported
 at a later time.
}
Function BRqShellInit(Var InitializationString): Integer;


IMPLEMENTATION

  {Standard Btrieve Operation Call}
Function BTRV(    Operation: integer;
              var posblk;
              var databuf;
              var datalen  : word;
              var keybuf;
                  keylen   : byte;
                  keynum   : byte): integer;
                     external 'WBTRCALL'  index 1;

  {This is a dummy function. It currently serves no purpose}
Function WBShellInit(Var InitializationString): Integer; far;
                     external 'WBTRCALL'  index 2;

  {Initializes the local DLL}
Function WBtrvInit(Var IntializationString): Integer;  far;
                     external 'WBTRCALL'  index 3;

  {Clears all internal Btrieve tables for this process}
Function WBtrvStop: Integer;  far;
                     external 'WBTRCALL'  index 4;

  {This function is currently not supported. You initialize brequest.exe
   when you load it before loading windows. Therefore, there is no need
   to initialize the WBTRCALL.DLL requestor from your Windows application}
Function WBRqShellInit(Var InitializationString): Integer; far;
                     external 'WBTRCALL'  index 5;



{Initializes the local DLL}
Function BtrvInit(Var InitializationString): Integer;
  Begin
    BtrvInit := WBtrvInit (InitializationString);
  End; {End BtrvInit}


{Stops this instance of Btrieve}
Function BtrvStop: Integer;
  begin
    BtrvStop:= WBtrvStop;
  end;


{Initializes the requestor DLL}
Function BRqShellInit(Var InitializationString): Integer;
  begin
    BRqShellInit:= WBRqShellInit(InitializationString);
  end;


BEGIN
END.

