===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 04-07-93 (20:24)             Number: 227
From: RICH GELDREICH               Refer#: NONE
  To: QUINN TYLER JACKSON           Recvd: NO  
Subj: Comp002c.bas 2/5               Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 2.

REDIM SHARED NextString(0)

DIM SHARED IsInitialized
DIM SHARED PowerOfTwo(0 TO 15) AS LONG
DIM SHARED OutputString$, OutputInfo AS BitOutputType
DIM SHARED BytesToCompress, UnCompressable

FUNCTION FunCompression (InText$)
    REDIM Dictionary(0 TO (DictSize + MaxMatch) - 1)
    REDIM HashTable(0 TO HashSize - 1)
    REDIM NextString(0 TO DictSize - 1)

    SrgLoadHashTable

    SlidePointer = 0
    StringPointer = 1
    BytesLeft = BytesToCompress

    DO UNTIL UnCompressable OR BytesLeft = 0
        'Dictionary all filled up?
        IF SlidePointer = DictSize THEN
            SlidePointer = DictSize - ZoneSize
            'Move dictionary "left" so more characters can be
            'thrown into it.
            SrgSlideDict
        END IF

        'Find how many bytes we can do in this zone...
        BytesToDo = ZoneSize
        IF BytesLeft < ZoneSize THEN
            BytesToDo = BytesLeft
        END IF

        'Enter new characters to compress into search structures.
        SrgHash InText$, SlidePointer, StringPointer, BytesToDo

        'Find matches for the characters.
        SrgSearch SlidePointer, BytesToDo

        BytesLeft = BytesLeft - BytesToDo
        StringPointer = StringPointer + BytesToDo
        SlidePointer = SlidePointer + ZoneSize
    LOOP

    'If data can't be compressed then just store it.
    IF UnCompressable THEN
        MID$(OutputString$, 17) = InText$
        OutputInfo.ByteOffset = 17 + BytesToCompress
        FunCompression = 0
    ELSE
        'Flush output buffer.
        SrgWriteBits 0, 8
        FunCompression = 1
    END IF

    REDIM Dictionary(0)
    REDIM HashTable(0)
    REDIM NextString(0)

END FUNCTION

FUNCTION FunGeldComp$ (InText$, ErrorCode)
    FunGeldComp$ = ""
    ErrorCode = 0

    IF IsInitialized = False THEN
        IsInitialized = True

        J& = 1
        FOR A = 0 TO 15
            PowerOfTwo(A) = J&
            J& = J& * 2
        NEXT
    END IF

    BytesToCompress = LEN(InText$)
    UnCompressable = False

    IF BytesToCompress = 0 THEN
        ErrorCode = -1
        EXIT FUNCTION

'>>> Continued on page 3

--- MsgToss 2.0b
 * Origin: Computer Co-Op - Voorhees, NJ | Ted Hare (1:266/29)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 280/1 390/1 396/1 15 397/2 2230/100 3603/20
