===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 04-07-93 (20:25)             Number: 228
From: RICH GELDREICH               Refer#: NONE
  To: QUINN TYLER JACKSON           Recvd: NO  
Subj: Comp002c.bas 3/5               Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 3.

    ELSEIF BytesToCompress > 32000 THEN
        ErrorCode = -2
        EXIT FUNCTION
    END IF

    OutputString$ = SPACE$(128 + BytesToCompress)
    OutputInfo.ByteOffset = 17
    OutputInfo.BitOffset = 0
    OutputInfo.BitBuffer = 0

    MID$(OutputString$, 1) = "REN"                  '1-3
    MID$(OutputString$, 4) = CHR$(Version)          '4-4
    MID$(OutputString$, 5) = MKI$(BytesToCompress)  '5-6

    Algorithm = FunCompression(InText$)

    MID$(OutputString$, 7) = MKI$(OutputInfo.ByteOffset - 17)'7-8
    MID$(OutputString$, 9) = CHR$(Algorithm)

    FunGeldComp$ = LEFT$(OutputString$, OutputInfo.ByteOffset)
    OutputString$ = ""
END FUNCTION

SUB SrgChar (BYVAL Char)

    SrgWriteBits Char * 2, 9

END SUB

SUB SrgHash (InText$, BYVAL SlidePointer, BYVAL StringPointer,_
 BYVAL TotalBytes)
    'Copy characters from input string into dictionary.
    J = SlidePointer
    FOR A = StringPointer TO StringPointer + TotalBytes - 1
        Dictionary(J) = ASC(MID$(InText$, A, 1))
        J = J + 1
    NEXT

    'Enter characters into hash table. Each three character
' sequence in
    'the dictionary is hashed and placed at the head of its
' linked list.
    'This ensures that each linked list is always sorted by
    'age, where the oldest strings (the least important strings)
' are near
    'the end of the linked list and the youngest strings are
' near the
    'head of the list. After hashing, compressing the data is a
' simple
    'matter of running down a string's linked list and comparing
' to find
    'the largest match.

    'Initialize the hash accumulator.
    Hash = (Dictionary(SlidePointer) * 32 XOR_
 Dictionary(SlidePointer + 1))

    FOR A = SlidePointer TO (SlidePointer + TotalBytes - 1) - 2
        'Shift left hash accumulator 5 places and XOR it with
        'the next character.
        Hash = (((Hash AND 1023) * 32) XOR Dictionary(A + 2))_
 AND (HashSize - 1)
        J = A

        'Make the new string the "head" of its linked list.

        'Make hash table entry point to new string.
        SWAP HashTable(Hash), J
        'Make new string point to old string.
        NextString(A) = J
    NEXT

    'Set the last two strings which weren't hashed in the above
' loop
    'to -1.
    FOR A = (SlidePointer + TotalBytes - 1) - 1 TO (SlidePointer_
 + TotalBytes - 1)
        IF A >= 0 THEN NextString(A) = -1
    NEXT

END SUB

'>>> Continued on page 4

--- MsgToss 2.0b
 * Origin: Computer Co-Op - Voorhees, NJ | Ted Hare (1:266/29)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 280/1 390/1 396/1 15 397/2 2230/100 3603/20
