===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 04-07-93 (20:27)             Number: 230
From: RICH GELDREICH               Refer#: NONE
  To: QUINN TYLER JACKSON           Recvd: NO  
Subj: Comp002c.bas 5/5               Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 5.

    DO UNTIL TotalBytes = 0 OR UnCompressable
        SrgScan SlidePointer, MatchPos1, MatchLen1

        'Add this code to increase compression, but decrease speed:
'        IF (MatchLen1 >= MinMatch) AND (MatchLen1 < 64) THEN
'            SrgScan SlidePointer + 1, MatchPos2, MatchLen2
'            IF MatchLen2 > MatchLen1 THEN
'                SrgChar Dictionary(SlidePointer)
'                SlidePointer = SlidePointer + 1
'                TotalBytes = TotalBytes - 1
'                IF TotalBytes = 0 THEN EXIT DO
'                MatchLen1 = MatchLen2
'                MatchPos1 = MatchPos2
'            END IF
'        END IF

        IF (MatchLen1 < MinMatch) OR (TotalBytes < MinMatch) THEN
            SrgChar Dictionary(SlidePointer)
        ELSE
            IF MatchLen1 > TotalBytes THEN
                MatchLen1 = TotalBytes
            END IF
            SrgMatch SlidePointer - MatchPos1, MatchLen1
        END IF

        TotalBytes = TotalBytes - MatchLen1
        SlidePointer = SlidePointer + MatchLen1
    LOOP

END SUB

'This subroutine slides the dictionary down ZoneSize characters and
'updates the hash table and linked lists.
SUB SrgSlideDict

    'Slide dictionary.
    FOR A = ZoneSize TO DictSize - 1
        Dictionary(A - ZoneSize) = Dictionary(A)
    NEXT

    'Slide linked list cells. Set any cell which points to a
' string
    'just slid out to -1.
    FOR A = ZoneSize TO DictSize - 1
        B = NextString(A) - ZoneSize
        'If B < 0, then set cell to -1, or null.
        NextString(A - ZoneSize) = B OR (B < 0)
    NEXT

    'Update hash table so it points to the correct strings.
    FOR A = 0 TO HashSize - 1
        B = HashTable(A) - ZoneSize
        HashTable(A) = B OR (B < 0)
    NEXT

END SUB

SUB SrgWriteBits (BYVAL Bits, BYVAL NumBits)

    OutputInfo.BitBuffer = OutputInfo.BitBuffer OR (Bits *_
 PowerOfTwo(OutputInfo.BitOffset))

    OutputInfo.BitOffset = OutputInfo.BitOffset + NumBits

    DO WHILE OutputInfo.BitOffset > 7
        MID$(OutputString$, OutputInfo.ByteOffset, 1) =_
 CHR$(OutputInfo.BitBuffer AND 255)
        OutputInfo.ByteOffset = OutputInfo.ByteOffset + 1

        OutputInfo.BitBuffer = OutputInfo.BitBuffer \ 256 'SHR 8
        OutputInfo.BitOffset = OutputInfo.BitOffset - 8

        IF OutputInfo.ByteOffset >= (BytesToCompress - 16) THEN
            UnCompressable = True
            EXIT SUB
        END IF

    LOOP

END SUB


--- MsgToss 2.0b
 * Origin: Computer Co-Op - Voorhees, NJ | Ted Hare (1:266/29)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 280/1 390/1 396/1 15 397/2 2230/100 3603/20
