{ Creates a large string collection of 50,000 random strings }

PROGRAM lcTest2;  { Large Colection Test app 2 }

USES

   largeCol,
   WinCrt,
   Objects,
   WinProcs,
   WinTYpes,
   Strings,
   WinDos;

CONST

   ListSize  = 20000;
   ListDelta = 10000;

   TestSetSize = 50000;

{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

PROCEDURE RunProc;
VAR
   AList : PLStrCollection;
   AFld1,AFld2 : ARRAY[0..80] OF CHAR;
   NumStr : ARRAY[0..20] OF CHAR;
   N,C : LONGINT;
   E : INTEGER;
   SH,SM,SS,SMS,EH,EM,ES,EMS : WORD;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION WriteFirst(AStr : PChar) : BOOLEAN; FAR;
   BEGIN
      IF N < 6 THEN
         Writeln(N,' - ',AStr);
      IF N > 6 THEN
         WriteFirst := TRUE
      ELSE
         WriteFirst := FALSE;
      INC(N);
   END;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

   FUNCTION WriteLast(AStr: PChar) : BOOLEAN; FAR;
   BEGIN
      IF N >= (TestSetSize-6) THEN
         Writeln(N,' - ',AStr);
      INC(N);
      WriteLast := FALSE
   END;

   { ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ }

BEGIN

   GetTime(SH,SM,SS,SMS);

   StrCopy(WindowTitle,'Large Collection Test 2');
   InitWinCrt;

   AList := NEW(PLStrCollection,Init(ListSize,ListDelta));
   AList^.Duplicates := TRUE;
   IF AList = NIL THEN
   BEGIN
      Writeln('Large collection INIT failed!');
      readln;
   END
   ELSE
   BEGIN
      randomize;
      FOR C := 0 TO (TestSetSize-1) DO
      BEGIN
         IF (C MOD 100) = 0 THEN
            writeln(C);
         FOR E := 0 TO 5 DO
            AFld1[E] := CHAR(65 + RANDOM(26));
         AFld1[6] := #0;
         AList^.Insert(StrNew(AFld1));
         IF AList^.Status <> lce_OK THEN
         BEGIN
            writeln('Error inserting item ',C);
            writeln('Error = ',AList^.Status);
            readln;
            halt(0);
         END
      END;

      N := 0;
      AList^.FirstThat(@WriteFirst);

      N := 0;
      AList^.FirstThat(@WriteLast);

      GetTime(EH,EM,ES,EMS);

      Writeln;
      writeln('Start = ',SH,':',SM,':',SS);
      writeln('End   = ',EH,':',EM,':',ES);

      writeln;
      Writeln('Hit any key to continue ....');
      readln;

   END;

   DISPOSE(AList,Done);

   DoneWinCrt;

END;


{ :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: }

BEGIN
   RunProc;
END.