===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 04-24-93 (11:41)             Number: 56
From: CORIDON HENSHAW              Refer#: 206
  To: JOEL YEN                      Recvd: NO  
Subj: ASM graphic SUB                Conf: (35) Quick Basi
---------------------------------------------------------------------------
Hello Joel!

Friday April 23 1993, Joel Yen writes to All Good Guy, You!!:

 JY> But I have faced a problem when I want to calculate the offset of a point
 JY> JY> in this asm routine. How could I calculate the offset directly in by
 JY> JY> ASSEMBLY (e.g. when x=200,y=55 offset=320*200+55)?

This should do the trick:

===CUT===
.MODAL MEDIUM, BASIC
.CODE

PUBLIC PlotPoint

PlotPoint PROC FAR USES AX BX DS SI, X:WORD, Y:WORD, Color:WORD
        MOV AX,320      ;Load width of screen into AX
        MOV BX,X        ;Load the X coordinate into BX
        MUL BL          ;Multply the lower portion of BX by AL.  Result in AX.
        ADD AX,Y        ;Add the Y coordinate to the result
        MOV SI,AX       ;Load the final offset into SI
        MOV DS,0A000H   ;Load the videobuffer segment into DS
        MOV [SI],Color  ;Plot one pixel of Color to the screen.
PlotPoint ENDP
END
===CUT===

And you DECLARE PlotPoint like this:

DECLARE SUB PlotPoint(BYVAL X%, BYVAL Y%, BYVAL ColorValue%)

This example just plots one pixel to the screen, but I think you can see the bas
ic princible behind calculating the offset.

Coridon Henshaw / Sirrus Software / QBCIMR FTSC Standards Technician / SM DEV

--- GEcho 1.00
 * Origin: TCS Concordia - Mail Only - Toronto, Ontario (1:250/820)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 280/1 390/1 396/1 15 397/2 2230/100 2440/5 3603/20
