===========================================================================
 BBS: The Abacus * HST/DS * Potterville MI
Date: 03-02-93 (16:01)             Number: 180
From: BRENT ASHLEY                 Refer#: NONE
  To: ALL                           Recvd: NO  
Subj: PROGRESS.FRM #4                Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 4 of PROGRESS.FRM

        PRINT #OutFile,
      END IF

      CLOSE #OutFile

      IF NOT EOF(InFile) THEN
        ' update counter
        FileOutNum = FileOutNum + 1
        LinesOut = 1
      END IF

  LOOP UNTIL EOF(InFile)

  ' show 100% if not aborted
  IF UserAbort = 0 THEN Dummy = ShowProgress(100, OutN$)
  CLOSE #InFile, #OutFile

END SUB

SUB PostIt (InFileName$, OutPrefix$, Ext$, LPP, Reserve, LineLength)

  Ver$ = "v5.0"

  ' initialization stuff
  DIM Shift(5)
  Shift(0) = 1
  Shift(1) = 2
  Shift(2) = 4
  Shift(3) = 8
  Shift(4) = 16
  Shift(5) = 32

  LinesOut = LinesOut + 2

  ValidChars$ = "abcdefghijklmnopqrstuvwxyz"
  ValidChars$ = ValidChars$ + "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789()"

  Qt$ = CHR$(34)
  Prefix$ = "G" + Qt$

  CurrentPage = 1
  Work$ = Prefix$
  CurrentBit = 0
  Char = 0

  ' extract base filename from input filename
  InFileBase$ = ""
  FOR I = LEN(InFileName$) TO 1 STEP -1
    ThisChar$ = MID$(InFileName$, I, 1)
    SELECT CASE ThisChar$
      CASE "\", ":", " "
        EXIT FOR
      CASE ELSE
        InFileBase$ = ThisChar$ + InFileBase$
    END SELECT
  NEXT

  ' Open input file
  InFile = FREEFILE
  OPEN InFileName$ FOR BINARY AS #InFile
  FileLen = LOF(InFile)

  ' Open output file.
  F$ = OutPrefix$ + RIGHT$(STR$(100 + CurrentPage), 2) + "." + Ext$
  OutFile = FREEFILE
  'use 8k output buffer for a little speed
  OPEN F$ FOR OUTPUT AS #OutFile LEN = 8192

  ' initialise progress with filename
  Dummy = ShowProgress(0, F$)

  'Print the first 2 lines of the loader.
  PRINT #OutFile,"CLS:?STRING$(50,178):'This file created by PostIt!"+ _
" "; Ver$
  PRINT #OutFile, "DEFINT A-Z:FOR A=0 TO 6:P(A)=2^A:NEXT:OPEN "; Qt$; _
 "B"; Qt$; ",1,"; Qt$; InFileBase$; Qt$
  PRINT #OutFile,"T$=";Qt$;"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMN"+ _
"OPQ" + "RSTUVWXYZ0123456789()"; Qt$

  ' we've already determined the file is less than 24k
  ' so we'll assume there's enough string space to hold it
  Buf$ = SPACE$(FileLen)
  GET #InFile, , Buf$

  FOR CurrentByte = 1 TO FileLen
    'shift the 8 bit character into the work buffer
    Char = Char + ASC(MID$(Buf$, CurrentByte, 1)) * Shift(CurrentBit)

    'we've got 8 more bits now
    CurrentBit = CurrentBit + 8

    'write the 6 bit codes now
    DO WHILE CurrentBit > 5         'do we have at least 6 bits left?
      GOSUB PutByte

'>>> Continued on page 5.
--- FidoPCB v1.4 beta
 * Origin: Canada Remote Systems, Mississauga, Ontario  (1:229/15)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 950 203/23 209/209 280/1
SEEN-BY: 390/1 396/1 15 397/2 2230/100 3603/20
