===========================================================================
 BBS: The Abacus * HST/DS * Potterville MI
Date: 03-02-93 (15:52)             Number: 176
From: BRENT ASHLEY                 Refer#: NONE
  To: ALL                           Recvd: NO  
Subj: POSTIT.FRM #4                  Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 4 of POSTIT.FRM

      MSGBOX m$, 0, "Oops!"
      EXIT SUB
    END IF

    ' analyse for binary or msgsplit
    Buf$ = SPACE$(32)
    GET #FileNum, , Buf$
    IsBinary = FALSE
    FOR I = 1 TO LEN(Buf$)
      SELECT CASE ASC(MID$(Buf$, I, 1))
        CASE 0 TO 8, 14 TO 31
          ' control codes
          IsBinary = TRUE
          EXIT FOR
        CASE 128 TO 178, 219 TO 255
          ' might be binary, might not
          HiAscii = HiAscii + 1
        CASE ELSE
          ' text ascii or linedraw
          ' passes through
      END SELECT
    NEXT
    ' set option according to analysed type
    IF IsBinary OR (HiAscii > 8) THEN
      optFmt(0).Value = TRUE
    ELSE
      optFmt(1).Value = TRUE
    END IF

    ' assign filespec to text box
    txtSource.text = PathName$ + FileName$

    ' extract prefix (first up to 6 chars of filename)
    DotPos = INSTR(FileName$, ".")
    IF DotPos THEN
      txtPrefix.text = LEFT$(LEFT$(FileName$, DotPos - 1), 6)
    ELSE
      txtPrefix.text = LEFT$(FileName$, 6)
    END IF

    ' we've got a file - get ready to do it
    cmdGo.SETFOCUS
  END IF

END SUB

SUB Form_Load ()
  ' get source filename from command line
  FileSpec$ = COMMAND$
  IF LEN(DIR$(FileSpec$)) THEN
    txtSource.text = FileSpec$

    ' extract base filename from input filename
    FileBase$ = ""
    FOR I = LEN(FileSpec$) TO 1 STEP -1
      ThisChar$ = MID$(FileSpec$, I, 1)
      SELECT CASE ThisChar$
        CASE "\", ":", " "
          EXIT FOR
        CASE ELSE
          FileBase$ = ThisChar$ + FileBase$
      END SELECT
    NEXT

    ' extract prefix (first up to 6 chars of filename)
    DotPos = INSTR(FileBase$, ".")
    IF DotPos THEN
      txtPrefix.text = LEFT$(LEFT$(FileBase$, DotPos - 1), 6)
    ELSE
      txtPrefix.text = LEFT$(FileBase$, 6)
    END IF

  END IF

  ' set up border and title colours
  SCREEN.ControlPanel(ACTIVE_BORDER_BACKCOLOR) = CYAN
  SCREEN.ControlPanel(TITLEBAR_BACKCOLOR) = BLUE
  SCREEN.ControlPanel(TITLEBAR_FORECOLOR) = YELLOW

  frmPostit.SHOW
  IF LEN(FileSpec$) = 0 THEN
    nl$ = CHR$(13) + CHR$(10)
    m$ = "           PostIt v5.0 for VB/DOS"
    m$ = m$ + nl$ + "                    ***" + nl$
    m$ = m$ + nl$ + "  PostIt by Rich Geldreich"
    m$ = m$ + nl$ + "  MsgSplit by Scott Wunsch and Victor Yiu  "
    m$ = m$ + nl$ + "  with mods by:"
    m$ = m$ + nl$ + "                Jim Giordano"
    m$ = m$ + nl$ + "                Mark H. Butler"
    m$ = m$ + nl$ + "                Quinn Tyler Jackson"
    m$ = m$ + nl$

'>>> Continued on page 5.
--- FidoPCB v1.4 beta
 * Origin: Canada Remote Systems, Mississauga, Ontario  (1:229/15)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 950 203/23 209/209 280/1
SEEN-BY: 390/1 396/1 15 397/2 2230/100 3603/20
