===========================================================================
 BBS: The Abacus * HST/DS * Potterville, MI
Date: 06-02-93 (12:35)             Number: 8
From: CORIDON HENSHAW              Refer#: NONE
  To: ALL                           Recvd: NO  
Subj: (02) BT8.BAS                   Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 2.

        Encode8 Infile$, Outfile$
        PLAY "A"
    CASE "2"
        LINE INPUT "Input file: ", Infile$
        PRINT
        PRINT "Decoding.  This may take some time."
        PRINT "Press any key to abort.  BT8 will beep when done."
        PRINT
        Decode8 Infile$
        PLAY "A"
END SELECT

FUNCTION CRC$ (File)
'InitCrcTab &HEDB8, &H8320   'Init CRC routines

FPos& = SEEK(File)          'Save position in file
SEEK File, 1                'Set filepos to start of file
BLft& = LOF(File) - LOC(File)'How many more bytes left?

DO
    IF BLft& >= 32767 THEN      'Do we have 32K or more bytes to read?
        Buffer$ = ""
        Buffer$ = STRING$(32766, 0)'Yup
    ELSE                        'Nope,
        Buffer$ = STRING$(BLft&, 0)'Read what's left
    END IF

    GET File, , Buffer$         'Read from file

    'CalcCRC SSEG(Buffer$), SADD(Buffer$), LEN(Buffer$)  'Pass to lib
' to calc

    BLft& = LOF(File) - LOC(File)'How many more bytes left?

LOOP UNTIL BLft& = 0             'Are we done yet?

SEEK File, FPos&

'CRC$ = HEX$(GetCRC)
'ResetCRC

'Delete the following line after you have unpacked the support lib:
CRC$ = "0"

END FUNCTION

SUB Decode8 (Infile$)

DIM Char(1 TO 6)    AS STRING * 1
DIM Block(1 TO 6)   AS STRING * 8
DIM Shift           AS INTEGER
DIM InBuffer        AS STRING
DIM OutBuffer       AS STRING

InH = FREEFILE
OPEN Infile$ FOR INPUT AS #InH

INPUT #InH, InBuffer
IF InBuffer + "," <> Header8 THEN
        PRINT "Not a BT8 script file"
        EXIT SUB
END IF
INPUT #InH, Outfile$                'Extract filename
INPUT #InH, InBuffer                'Read file size
Size& = VAL("&H" + InBuffer)        'Filesize is stored in hex to save
' space.
INPUT #InH, CrcValue$               'Read file CRC
INPUT #InH, FDate$                  'Read file date
INPUT #InH, FTime$                  'Read file time

FPos = SEEK(InH)

DO
    LINE INPUT #InH, InBuffer
    IF LEFT$(InBuffer, LEN(Footer8)) = Footer8 THEN
        NumBlocks& = VAL("&H" + MID$(InBuffer, LEN(Footer8) + 1))
        Flag = 1
    ELSEIF EOF(InH) THEN
        Flag = 2
    END IF
LOOP UNTIL Flag = 1 OR Flag = 2

'>>> See Next Page >>>

--- GEcho 1.00
 * Origin: Ask me about the GRAPHICS_PROG echo! (1:250/820)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/110 159/100 125 430 575 950 203/23 209/209
SEEN-BY: 261/1023 280/1 390/1 396/1 15 397/2 2230/100 2440/5 3603/20
