#ifndef MonoIncluded
#define MonoIncluded

// written by Paul Wheaton

/*

This is something that I wrote real quick to provide a way to display
certain info on the mono screen while the color screen is being used in
graphics or text mode for primary information display.

See WW.ZIP for a complete library for dual screen access.

*/

//  Note that X has the range 1..80 and Y has the range 1..25

void MonoClear();
void MonoColorLine(int Y,int Att);
void MonoSave();
void MonoReplace();

const MonoNormal=7;
const MonoReverse=0x70;
const MonoBright=15;

class MonoTextWindow
  {
      int TY; // Top Y Pos: 1..25
      int H;  // How high the window is:1..25
    public:
      MonoTextWindow(int TopY,int High);
      void Display(char* S,int X, int LocalY);
      void ScrollUp();
      void ScrollDown();
  };

#endif

