===========================================================================
 BBS: The Abacus * HST/DS * Potterville MI
Date: 03-02-93 (15:55)             Number: 179
From: BRENT ASHLEY                 Refer#: NONE
  To: ALL                           Recvd: NO  
Subj: PROGRESS.FRM #2                Conf: (35) Quick Basi
---------------------------------------------------------------------------
'>>> Start of page 2 of PROGRESS.FRM

  frmPostit.Enabled = FALSE

  ' get call parameters from control values
  InFileName$ = LTRIM$(RTRIM$(frmPostit.txtSource.text))
  OutPrefix$ = LTRIM$(RTRIM$(frmPostit.txtPrefix.text))
  Ext$ = LTRIM$(RTRIM$(frmPostit.txtExt.text))
  LPP = VAL(frmPostit.txtLen.text)
  Reserve = VAL(frmPostit.txtRsvd.text)
  LineLength = 72

  ' show current form
  frmProgress.SHOW

  ' do it
  InProgress = TRUE
  IF frmPostit.optFmt(0).Value THEN
    ' binary postit
    frmProgress.Caption = "Binary Postit"
    PostIt InFileName$, OutPrefix$, Ext$, LPP, Reserve, LineLength
  ELSE
    ' text msgsplit
    frmProgress.Caption = "Text MsgSplit"
    MsgSplit InFileName$, OutPrefix$, Ext$, LPP, Reserve, LineLength
  END IF
  BEEP
  InProgress = FALSE

  ' show result on exit button
  IF Abort THEN
    cmdAbort.Caption = "Aborted - E&xit"
  ELSE
    cmdAbort.Caption = "Done - E&xit"
  END IF
END SUB

SUB Form_Unload (Cancel AS INTEGER)
  ' re-enable main form controls
  frmPostit.Enabled = TRUE
  ' set focus to exit button
  frmPostit.cmdExit.SETFOCUS
  ' clear flag for further calls
  Abort = FALSE
END SUB

SUB MsgSplit (InFileName$, OutPrefix$, Ext$, LPP, Reserve, LineLength)

  ' initialize things
  Ver$ = "v5.0"
  Tab$ = CHR$(9)
  Quote$ = CHR$(34)
  Snip1$ = "______O_/_________________| SNIP |________________\_O_____"
  Snip2$ = "      O \                 | HERE |                / O"
  LinesOut = Reserve + 1
  FileOutNum = 1
  LPP = LPP - 4   ' lines per page

  ' extract base filename from input filename
  InFileBase$ = ""
  FOR I = LEN(InFileName$) TO 1 STEP -1
    ThisChar$ = MID$(InFileName$, I, 1)
    SELECT CASE ThisChar$
      CASE "\", ":", " "
        EXIT FOR
      CASE ELSE
        InFileBase$ = ThisChar$ + InFileBase$
    END SELECT
  NEXT

  ' open input file and get file length
  InFile = FREEFILE
  OPEN InFileName$ FOR INPUT AS #InFile
  FileLen = LOF(InFile)

  DO
    ' build outfile name - use leading zeros so filenames sort properly
    OutN$ = OutPrefix$ + RIGHT$(STR$(100 + FileOutNum), 2) + "." + Ext$

    OutFile = FREEFILE
    OPEN OutN$ FOR OUTPUT AS #OutFile

    IF FileOutNum > 1 THEN
      PRINT #OutFile, "'>>> Start of page"; STR$(FileOutNum); " of "; _
 InFileBase$
      PRINT #OutFile,
    ELSE
      PRINT #OutFile, Snip1$
      PRINT #OutFile, Snip2$
      PRINT #OutFile, "'This file created by PostIt! "; Ver$
      PRINT #OutFile, "'>>> Start of page"; STR$(FileOutNum); " of "; _
 InFileBase$
      PRINT #OutFile,
    END IF

'>>> Continued on page 3.
--- FidoPCB v1.4 beta
 * Origin: Canada Remote Systems, Mississauga, Ontario  (1:229/15)
SEEN-BY: 1/211 11/2 4 13/13 101/1 108/89 109/25 110/69 114/5 123/19 124/1
SEEN-BY: 153/752 154/40 77 157/2 159/100 125 430 950 203/23 209/209 280/1
SEEN-BY: 390/1 396/1 15 397/2 2230/100 3603/20
