===========================================================================
 BBS: The Abacus * HST/DS * Potterville MI
Date: 04-09-93 (08:14)             Number: 45
From: HARVEY PARISIEN              Refer#: NONE
  To: EARL MONTGOMERY               Recvd: NO  
Subj: READREP.BAS  1/2               Conf: (35) Quick Basi
---------------------------------------------------------------------------
On (07 Apr 93) Earl Montgomery wrote to Dik Coates...

 EM> Thanks for the sources. But I THINK Harvey Parisien MIGHT help me
 EM> out.
 EM>
 EM> Thanks again

Here's that code sample...

'--------------------------------------------------------------------------
' Author: Harvey Parisien
' Copyright (c) 1993 Harvey Parisien, all rights reserved.
' Overerx Inc., Box 323 Station A, Kingston, Ontario, Canada  K7M 6R2
' FidoNet: 1:249/114
'--------------------------------------------------------------------------
' Program: READREP.EXE
' Purpose: Quick and dirty REP packet unarchiver reader
'--------------------------------------------------------------------------
' This code can be used by anyone.  It has been stripped of it's normal
' video routines so it can be run in any environment QB or PDS etc.  It
' is intended for use as a simple REP packet check, or for informational
' purposes.  There are a few routines that could possibly help in further
' developing QWK readers.  Enjoy... HP

DEFINT A-Z
DECLARE FUNCTION autounarc$ (arcname$)
DECLARE SUB dism (message$, array$(), numlines%, Ret%, maxwid%)
DECLARE SUB tlist (array$(), numlines%, maxwid%, Rows%, trow%, lcol%, Ret%)
DECLARE FUNCTION scan% ()
DECLARE FUNCTION Exist (filename$)
DECLARE SUB display (filename$)

TYPE RegTypeX
   AX    AS INTEGER
   bx    AS INTEGER
   CX    AS INTEGER
   DX    AS INTEGER
   bp    AS INTEGER
   si    AS INTEGER
   di    AS INTEGER
   flags AS INTEGER
   DS    AS INTEGER
   es    AS INTEGER
END TYPE

TYPE dat
   flag AS STRING * 1
   num AS STRING * 7
   date AS STRING * 8
   time AS STRING * 5
   to AS STRING * 25
   From AS STRING * 25
   subject AS STRING * 25
   Pass AS STRING * 12
   ref AS STRING * 8
   blocks AS STRING * 6
   status AS STRING * 1
   area AS STRING * 1
   dummy AS STRING * 4
END TYPE

TYPE block
   a AS STRING * 128
END TYPE

DIM SHARED dat AS dat
DIM SHARED block AS block

CLS
filename$ = COMMAND$                'get filename
IF LEN(filename$) = 0 THEN
   PRINT "USE: READREP reparchivename.ext"
   END
END IF
arccmd$ = autounarc$(filename$)     'get unarchive command
PRINT arccmd$                       'print unarchive command
SHELL arccmd$                       'shell out and unarchive
F$ = filename$                      'create local packet name
MID$(F$, LEN(F$) - 2) = "MSG"
i = INSTR(F$, "\")
DO WHILE i > 0
   F$ = MID$(F$, i + 1)
   i = INSTR(F$, "\")
LOOP
CALL display(F$)
END

FUNCTION autounarc$ (arcname$)
   autounarc$ = ""
   IF NOT Exist(arcname$) THEN EXIT FUNCTION
   'get archive id markers
   ff = FREEFILE
   OPEN arcname$ FOR BINARY AS ff
   tem1$ = SPACE$(5)
   tem2$ = SPACE$(1)
   GET #ff, 1, tem1$
   GET #ff, LOF(ff) - 1, tem2$
   CLOSE ff
   'test for archive type and unarchive
   IF LEFT$(tem1$, 4) = "PK" + CHR$(3) + CHR$(4) THEN
      autounarc$ = "PKUNZIP -o " + arcname$
   ELSEIF RIGHT$(tem1$, 3) = "-lh" THEN
      autounarc$ = "LHA e " + arcname$
   ELSEIF LEFT$(tem1$, 2) = "`" + CHR$(234) THEN
      autounarc$ = "ARJ e " + arcname$
   ELSEIF LEFT$(tem1$, 3) = "ZOO" THEN
      autounarc$ = "ZOO e " + arcname$
   ELSEIF tem2$ = CHR$(254) THEN
      autounarc$ = "PAK e /wa " + arcname$
   ELSEIF LEFT$(tem1$, 1) = CHR$(26) THEN
      autounarc$ = "PKUNPAK /r " + arcname$
   ELSE
      PRINT "UNKNOWN ARCHIVE TYPE: " + arcname$
   END IF

END FUNCTION

SUB dism (message$, array$(), numlines%, Ret%, maxwid%)
   start = 1
   numlines% = 0
   GOSUB geti
   DO WHILE i > 0
      numlines% = numlines% + 1
      IF i > start THEN
         IF i - start > maxwid THEN
            st = start + maxwid
            EN = start
            FOR iq = st TO EN STEP -1
               IF MID$(message$, iq, 1) = " " THEN
                  EXIT FOR
               END IF
            NEXT
            IF iq < EN + 10 THEN
               i = EN + maxwid
            ELSE
               i = iq
            END IF
         END IF
         ttem$ = MID$(message$, start, (i - 1) - (start - 1))
         array$(numlines%) = ttem$
         start = i + 1
         IF MID$(message$, start, 1) = CHR$(10) THEN start = start + 1
         GOSUB geti
      ELSEIF i = start THEN
         array$(numlines%) = ""
         start = i + 1
         IF MID$(message$, start, 1) = CHR$(10) THEN start = start + 1
         GOSUB geti
      ELSE
